-- Put your target database name at the next line
USE [OData_20160204]

GO

DECLARE @locAuthMethod varchar(50)
-- Define used authentication metod at the next line
SET @locAuthMethod='Token'

DECLARE @locAdminRoleID int

INSERT INTO [RWAD_OData].[Role]([Name])
VALUES (N'Admin');

SELECT @locAdminRoleID = @@IDENTITY

DECLARE @ActionsTable TABLE (ActionName varchar(255))

-- Fill temp table with actions (Permissions) list
INSERT INTO @ActionsTable(ActionName) VALUES('GetListOf')
INSERT INTO @ActionsTable(ActionName) VALUES('Create')
INSERT INTO @ActionsTable(ActionName) VALUES('Update')
INSERT INTO @ActionsTable(ActionName) VALUES('Delete')

-- Fill Permissions table
INSERT INTO RWAD_OData.[Permission](TableName, ActionName)
SELECT TablesList.TABLE_NAME, ActionsList.ActionName FROM
	(SELECT TABLE_NAME  
		FROM information_schema.tables 
		WHERE TABLE_TYPE=N'BASE TABLE'
	) TablesList
FULL JOIN 
	(SELECT ActionName FROM @ActionsTable) ActionsList
ON TablesList.TABLE_NAME=TablesList.TABLE_NAME
ORDER BY TablesList.TABLE_NAME

-- Fill PermissionRole table
INSERT INTO RWAD_OData.[PermissionRole](RoleID, PermissionID, IsEnabled)
SELECT
	@locAdminRoleID,
	perm.PermissionID,
	1
FROM RWAD_OData.[Permission] as perm

DECLARE @locAdminUserID bigint

-- Create User account (initial pass = '111111', Salt='initialSalt')
-- Password encoded by https://www.base64encode.org/
IF (@locAuthMethod = 'Basic')
	INSERT INTO [RWAD_OData].[User]([Login],[Password],[PasswordSalt])
	VALUES (N'Admin',N'QWRtaW46MTExMTEx','Admin')
ELSE
	INSERT INTO [RWAD_OData].[User]([Login],[Password],[PasswordSalt])
	VALUES (N'Admin',N'OQJXa3WcDSKdSYE8msaiv/owgcX0pNdmexZD2f4nw5E=','someSalt')

SELECT @locAdminUserID=@@IDENTITY

-- Assign Admin account to Admin Role
INSERT INTO [RWAD_OData].[UserRole](UserID,RoleID)
VALUES(@locAdminUserID,@locAdminRoleID)


GO